routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::middleware(['auth'])->group(function () {
    
    /* Resources */
    Route::resource('faculties', 'FacultyController');
    Route::resource('posts', 'PostController');
    Route::resource('universities', 'UniversityController');
    
    /* Custom */
    Route::get('profile', 'ProfileController@show');
});

app/Faculty.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Faculty extends Model
{
    //
    protected $fillable = ['name','university_id'];

    public function university(){
        return $this->belongsTo('App\University');
    }
}

app/Http/Controllers/FacultyController.php
<?php

namespace App\Http\Controllers;

use App\Faculty;
use App\University;
use Illuminate\Http\Request;

class FacultyController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $faculties = Faculty::all();
        return view('faculties.index', [
            'faculties' => $faculties
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $universities = University::select('id', 'name')->get();
        return view('faculties.create', [
            'universities' => $universities,
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'name'=>'required',
            'university_id'=>'required',
        ]);
        
        $faculty = new Faculty([
            'name' => $request->get('name'),
            'university_id' => $request->get('university_id'),
        ]);
        $faculty->save();
        return redirect('/faculties')->with('success', 'Facultad cargada con exito!');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Faculty  $faculty
     * @return \Illuminate\Http\Response
     */
    public function show(Faculty $faculty)
    {
        return view ('faculties.show', ['faculty'=>$faculty]); 
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Faculty  $faculty
     * @return \Illuminate\Http\Response
     */
    public function edit(Faculty $faculty)
    {
        $universities = University::select('id', 'name')->get();
        return view('faculties.edit', [
            'universities' => $universities,
            'faculty' => $faculty
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Faculty  $faculty
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Faculty $faculty)
    {
         $request->validate([
            'name'=>'required',
            'university_id'=>'required'
        ]);

        $faculty->name = $request->get('name');
        $faculty->university_id = $request->get('university_id');
        $faculty->save();
        return redirect('/faculties')->with('success', '¡Facultad actualizada con éxito!');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Faculty  $faculty
     * @return \Illuminate\Http\Response
     */
    public function destroy(Faculty $faculty)
    {
        $faculty->delete();
        return redirect('/faculties')->with('success', '¡Facultad borrada con éxito!');

    }
}

resources/views/faculties/create.blade.php
@extends('layouts.app')

@section('content')
<div class="row">
 <div class="col-sm-8 offset-sm-2">
    <h1 class="display-3">Agregar Facultad</h1>
  <div>
    @if ($errors->any())
      <div class="alert alert-danger">
        <ul>
            @foreach ($errors->all() as $error)
              <li>{{ $error }}</li>
            @endforeach
        </ul>
      </div><br />
    @endif
      <form method="post" action="{{ route('faculties.store') }}">
          @csrf
          <div class="form-group">    
              <label for="name">Nombre:</label>
              <input type="text" class="form-control" name="name"/>
          </div>

          <div class="form-group">
              <label for="university_id">Universidad:</label>
              <select type="text" class="form-control" name="university_id" id="">
                <option disabled selected>Seleccione una universidad...</option>
                @foreach($universities as $university)
                  <option value="{{ $university->id }}">{{ $university->name }}</option>
                @endforeach
              </select>
          </div>
                         
          <button type="submit" class="btn btn-primary-outline">Agregar facultad</button>
      </form>
  </div>
</div>
</div>
@endsection

resources/views/faculties/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
<div class="row justify-content-center mb-4">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Editar facultad</div>

                <div class="card-body">
                  <form class="" method="post" action="{{ route('faculties.update', $faculty->id) }}">
                  @method('PATCH')
                  @csrf
                  @if ($errors->any())
                  <div class="alert alert-danger">
                      <ul>
                          @foreach ($errors->all() as $error)
                          <li>{{ $error }}</li>
                          @endforeach
                      </ul>
                  </div>
                  <br />
                  @endif

                  <div class="form-group">
                    <label for="faculty">Faculty</label>
                    <input type="text" class="form-control" name="name" value="{{ $faculty->name }}"/>
                  </div>

                  <div class="form-group">
                    <label for="university_id">Universidad:</label>
                    
                    <select type="text" class="form-control" name="university_id" id="">
                      <option disabled>Seleccione una universidad...</option>
                      @foreach($universities as $university)
                        <option value="{{ $university->id }}" {{ $university->id == $faculty->university_id ? 'selected' : '' }}>{{ $university->name }}</option>
                      @endforeach
                    </select>
                  </div>

                  <button type="submit" class="btn btn-primary">Actualizar facultad</button>
                </form>
              </div>
            </div>
        </div>
    </div>
</div>

@endsection

resources/views/faculties/index.blade.php
@extends('layouts.app')

@section('content')
<div class="row">
<div class="col-sm-12">
    <h1 class="display-3">Facultades</h1>    
  <table class="table table-striped">
    <thead>
        <a href=" {{ route('faculties.create') }}" class="btn btn-primary" >Agregar</a>
        @if(session()->get('success'))
                    <div class="alert alert-success">
                     {{ session()->get('success') }}  
                    </div>
                @endif
        <tr>
          <td>Nombre</td>
          <td colspan = 4>Universidad</td>          
        </tr>
    </thead>
    <tbody>
        @foreach($faculties as $faculty)
        <tr>
            <td><a href=" {{ route('faculties.show', $faculty->id) }}"> {{ $faculty->name }} </a></td>
            <td>{{ $faculty->university_id }}</td>     
            <td> 
                <a href="{{ route('faculties.edit',$faculty->id)}}" class="btn btn-primary">Editar</a>
            </td> 
            <td>
                <form action="{{ route('faculties.destroy', $faculty->id)}}" method="post">
                  @csrf
                  @method('DELETE')
                  <button class="btn btn-danger" type="submit">Borrar</button>
                </form>
            </td>
        </tr>
        @endforeach
    </tbody>
  </table>
<div>
</div>
@endsection

resources/views/faculties/show.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Detalle de la facultad</div>               
                @if(session()->get('success'))
                    <div class="alert alert-success">
                     {{ session()->get('success') }}  
                    </div>
                @endif
                <div class="card-body">
                <ul>
                    <li>Nombre: {{ $faculty->name }}</li>
                    <li>Universidad: {{ $faculty->university_id}}</li>               
                </ul>   
                </div>
            </div>
        </div>
    </div>
</div>
@endsection